*** old-NetBSD/src/sys/arch/amiga/amiga/cc.c
--- NetBSD/src/sys/arch/amiga/amiga/cc.c
***************
*** 323,334 ****
   */
  
  struct audio_channel {
! 	u_short  play_count;
  };
  
  /* - channel[4] */
  /* the data for each audio channel and what to do with it. */
! static struct audio_channel channel[4];
  
  /* audio vbl node for vbl function  */
  struct vbl_node audio_vbl_node;    
--- 323,335 ----
   */
  
  struct audio_channel {
! 	u_short  play_count;		/* number of times to loop sample */
! 	handler_func_t handler;		/* interupt handler for channel */
  };
  
  /* - channel[4] */
  /* the data for each audio channel and what to do with it. */
! struct audio_channel channel[4];
  
  /* audio vbl node for vbl function  */
  struct vbl_node audio_vbl_node;    
***************
*** 337,342 ****
--- 338,344 ----
  cc_init_audio()
  {
  	int i;
+ 	extern int defchannel_handler();
  
  	/*
  	 * disable all audio interupts
***************
*** 346,353 ****
  	/*
  	 * initialize audio channels to off.
  	 */
! 	for (i=0; i < 4; i++)
  		channel[i].play_count = 0;
  }
  
  
--- 348,357 ----
  	/*
  	 * initialize audio channels to off.
  	 */
! 	for (i=0; i < 4; i++) {
  		channel[i].play_count = 0;
+ 		channel[i].handler = defchannel_handler;
+ 	}
  }
  
  
***************
*** 393,414 ****
  		if ((ir & (flag << 7)) == 0)
  			continue;
  
! 		if (channel[i].play_count)
! 			channel[i].play_count--;
! 		else {
! 			/*
! 			 * disable DMA to this channel and
! 			 * disable interrupts to this channel
! 			 */
! 			custom.dmacon = flag;
! 			custom.intena = (flag << 7);
! 		}
  		/*
  		 * clear this channels interrupt.
  		 */
  		custom.intreq = (flag << 7);
  	}
- 
  out:
  	/*
  	 * enable audio interupts with dma still set.
--- 397,410 ----
  		if ((ir & (flag << 7)) == 0)
  			continue;
  
! 		if (channel[i].handler)
! 			channel[i].handler(i);
! 
  		/*
  		 * clear this channels interrupt.
  		 */
  		custom.intreq = (flag << 7);
  	}
  out:
  	/*
  	 * enable audio interupts with dma still set.
***************
*** 418,423 ****
--- 414,439 ----
  	custom.intena = INTF_SETCLR | (audio_dma << 7);
  }
  
+ /*
+  * this is the channel handler used by the system
+  * other software modules are free to install their own
+  * handler
+  */
+ defchannel_handler(i)
+ 	int i;
+ {
+ 	if (channel[i].play_count)
+ 		channel[i].play_count--;
+ 	else {
+ 		/*
+ 		 * disable DMA to this channel and
+ 		 * disable interrupts to this channel
+ 		 */
+ 		custom.dmacon = (1 << i);
+ 		custom.intena = (1 << (i + 7));
+ 	}
+ }
+ 
  void
  play_sample(len, data, period, volume, channels, count)
  	u_short len, *data, period, volume, channels;
***************
*** 430,442 ****
  
  	/* load the channels */
  	for (ch = 0; ch < 4; ch++) {
! 		if ((dmabits & (ch << ch)) == 0)
  			continue;
! 		custom.aud[ch].len = len;
! 		custom.aud[ch].lc = data;
  		custom.aud[ch].per = period;
  		custom.aud[ch].vol = volume;
! 		channel[ch].play_count = count;
  	}
  	/*
  	 * turn on interrupts and enable dma for channels and
--- 446,461 ----
  
  	/* load the channels */
  	for (ch = 0; ch < 4; ch++) {
! 		if ((dmabits & (1 << ch)) == 0)
  			continue;
! 		/* busy */
! 		if (channel[ch].handler != defchannel_handler)
! 			continue;
! 		channel[ch].play_count = count;
  		custom.aud[ch].per = period;
  		custom.aud[ch].vol = volume;
! 		custom.aud[ch].len = len;
! 		custom.aud[ch].lc = data;
  	}
  	/*
  	 * turn on interrupts and enable dma for channels and
*** old-NetBSD/src/sys/arch/amiga/amiga/cc.h
--- NetBSD/src/sys/arch/amiga/amiga/cc.h
***************
*** 147,152 ****
--- 147,154 ----
  #define CHIPMEMTOP	(0x00200000)
  #define NCHIPMEMPG	btoc(CHIPMEMTOP - CHIPMEMBASE)
  
+ typedef int (*handler_func_t)();
+ 
  /*
   * Prototypes.
   */
*** old-NetBSD/src/sys/arch/amiga/amiga/conf.c
--- NetBSD/src/sys/arch/amiga/amiga/conf.c
***************
*** 94,99 ****
--- 94,109 ----
  };
  int	nblkdev = sizeof(bdevsw) / sizeof(bdevsw[0]);
  
+ #if 0
+ /* ioctl */
+ #define	cdev_aconf_init(c,n) { \
+ 	(dev_type_open((*))) nullop, (dev_type_close((*))) nullop, \
+ 	(dev_type_read((*))) nullop, (dev_type_write((*))) nullop, \
+ 	dev_init(c,aconf,ioctl), (dev_type_stop((*))) enodev, 0, seltrue, \
+         (dev_type_map((*))) enodev, 0 \
+ }
+ #endif
+ 
  /* open, close, ioctl, select, mmap -- XXX should be a map device */
  #define	cdev_grf_init(c,n) { \
  	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) nullop, \
***************
*** 114,119 ****
--- 124,135 ----
  	dev_init(c,n,write), dev_init(c,n,ioctl), (dev_type_stop((*))) enodev, \
  	0, (dev_type_select((*))) enodev, (dev_type_mmap((*))) enodev }
  
+ /* open, close, write, ioctl */
+ #define	cdev_lpt_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) enodev, \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), (dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev }
+ 
  cdev_decl(cn);
  cdev_decl(ctty);
  #define	mmread	mmrw
***************
*** 128,133 ****
--- 144,153 ----
  #define	ptcioctl	ptyioctl
  cdev_decl(ptc);
  cdev_decl(log);
+ #if 0
+ #include "aconf.h"
+ cdev_decl(aconf);
+ #endif
  cdev_decl(sd);
  cdev_decl(cd);
  #include "grf.h"
***************
*** 156,161 ****
--- 176,184 ----
  #include "bpfilter.h"
  cdev_decl(bpf);
  #include "tun.h"
+ #if 0
+ #define tunioctl tuncioctl /* XXX could be needed.  Markus had it...  */
+ #endif
  cdev_decl(tun);
  #ifdef LKM
  #define NLKM 1
***************
*** 163,168 ****
--- 186,195 ----
  #define NLKM 0
  #endif
  cdev_decl(lkm);
+ #include "com.h"
+ cdev_decl(com);
+ #include "lpt.h"
+ cdev_decl(lpt);
  
  struct cdevsw	cdevsw[] =
  {
***************
*** 173,179 ****
  	cdev_tty_init(NPTY,pts),	/* 4: pseudo-tty slave */
  	cdev_ptc_init(NPTY,ptc),	/* 5: pseudo-tty master */
  	cdev_log_init(1,log),		/* 6: /dev/klog */
- 	cdev_disk_init(NCCD,ccd),	/* 7: concatenated disk driver */
  	cdev_disk_init(NSD,sd),		/* 8: SCSI disk */
  	cdev_disk_init(NCD,cd),		/* 9: SCSI CD-ROM */
  	cdev_grf_init(NGRF,grf),	/* 10: frame buffer */
--- 200,205 ----
***************
*** 199,204 ****
--- 225,233 ----
  	cdev_lkm_dummy(),		/* 28 */
  	cdev_lkm_dummy(),		/* 29 */
  	cdev_lkm_dummy(),		/* 30 */
+ 	cdev_tty_init(NCOM,com),	/* 31: ISA serial port */
+ 	cdev_lpt_init(NLPT,lpt),	/* 32: parallel printer */
+ 	cdev_aconf_init(NACONF,aconf),  /* 33: /dev/autoconfig */
  };
  int	nchrdev = sizeof(cdevsw) / sizeof(cdevsw[0]);
  
***************
*** 291,296 ****
--- 320,327 ----
  	/* 28 */	NODEV,
  	/* 29 */	NODEV,
  	/* 30 */	NODEV,
+ 	/* 31 */	NODEV,
+ 	/* 32 */	NODEV,
  };
  
  /*
***************
*** 317,322 ****
--- 348,354 ----
   */
  cons_decl(ser);
  cons_decl(ite);
+ cons_decl(com);
  
  struct	consdev constab[] = {
  #if NSER > 0
***************
*** 324,329 ****
--- 356,366 ----
  #endif
  #if NITE > 0
  	cons_init(ite),
+ #endif
+ #if 0
+ #if NCOM > 0
+ 	cons_init(com),
+ #endif
  #endif
  	{ 0 },
  };
*** /dev/null
--- NetBSD/src/sys/arch/amiga/amiga/db_memrw.c
***************
*** 0 ****
--- 1,161 ----
+ /*	$NetBSD: db_memrw.c,v 1.4 1994/11/28 19:33:08 gwr Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994 Gordon W. Ross
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ 
+ /*
+  * Interface to the debugger for virtual memory read/write.
+  * To write in the text segment, we have to first make
+  * the page writable, do the write, then restore the PTE.
+  * For reads, validate address first to avoid MMU trap.
+  */
+ 
+ #include <sys/param.h>
+ #include <sys/proc.h>
+ 
+ #include <vm/vm.h>
+ 
+ #include <machine/db_machdep.h>
+ #include <machine/pte.h>
+ 
+ /*
+  * Read one byte somewhere in the kernel.
+  * It does not matter if this is slow. -gwr
+  */
+ static char
+ db_read_data(src)
+ 	char *src;
+ {
+ 	u_int *pte;
+ 	vm_offset_t pgva;
+ 	int ch;
+ 
+ 	pgva = amiga_trunc_page((long)src);
+ 	pte = kvtopte(pgva);
+ 
+ 	if ((*pte & PG_V) == 0) {
+ 		db_printf(" address 0x%x not a valid page\n", src);
+ 		return 0;
+ 	}
+ 	return (*src);
+ }
+ 
+ /*
+  * Read bytes from kernel address space for debugger.
+  * It does not matter if this is slow. -gwr
+  */
+ void
+ db_read_bytes(addr, size, data)
+ 	vm_offset_t	addr;
+ 	register int	size;
+ 	register char	*data;
+ {
+ 	char	*src, *limit;
+ 
+ 	src = (char *)addr;
+ 	limit = src + size;
+ 
+ 	while (src < limit) {
+ 		*data = db_read_data(src);
+ 		data++;
+ 		src++;
+ 	}
+ }
+ 
+ /*
+  * Write one byte somewhere in kernel text.
+  * It does not matter if this is slow. -gwr
+  */
+ static void
+ db_write_text(dst, ch)
+ 	char *dst;
+ 	int ch;
+ {
+ 	u_int *pte, oldpte;
+ 	vm_offset_t pgva;
+ 
+ 	pgva = amiga_trunc_page((long)dst);
+ 	pte = kvtopte(pgva);
+ 	oldpte = *pte;
+ 	if ((oldpte & PG_V) == 0) {
+ 		db_printf(" address 0x%x not a valid page\n", dst);
+ 		return;
+ 	}
+ 
+ 	*pte = oldpte & ~PG_RO;
+ 
+ 	*dst = (char) ch;
+ 
+ 	*pte = oldpte;
+ }
+ 
+ /*
+  * Write one byte somewhere outside kernel text.
+  * It does not matter if this is slow. -gwr
+  */
+ static void
+ db_write_data(dst, ch)
+ 	char *dst;
+ 	int ch;
+ {
+ 	u_int *pte;
+ 	vm_offset_t pgva;
+ 
+ 	pgva = amiga_trunc_page((long)dst);
+ 	pte = kvtopte(pgva);
+ 
+ 	if ((*pte & (PG_V | PG_RO)) != PG_V) {
+ 		db_printf(" address 0x%x not a valid page\n", dst);
+ 		return;
+ 	}
+ 	*dst = (char) ch;
+ }
+ 
+ /*
+  * Write bytes to kernel address space for debugger.
+  */
+ void
+ db_write_bytes(addr, size, data)
+ 	vm_offset_t	addr;
+ 	int	size;
+ 	char	*data;
+ {
+ 	extern char	etext[] ;
+ 	char	*dst, *limit;
+ 
+ 	dst = (char *)addr;
+ 	limit = dst + size;
+ 
+ 	while (dst < limit) {
+ 		if (dst < etext)	/* kernel text starts at 0 */
+ 			db_write_text(dst, *data);
+ 		else
+ 			db_write_data(dst, *data);
+ 		dst++;
+ 		data++;
+ 	}
+ }
*** old-NetBSD/src/sys/arch/amiga/amiga/genassym.c
--- NetBSD/src/sys/arch/amiga/amiga/genassym.c
***************
*** 110,115 ****
--- 110,116 ----
  	printf("#define\tT_TRAP15 %d\n", T_TRAP15);
  	printf("#define\tPSL_S %d\n", PSL_S);
  	printf("#define\tPSL_IPL7 %d\n", PSL_IPL7);
+ 	printf("#define\tPSL_IPL %d\n", PSL_IPL);
  	printf("#define\tPSL_LOWIPL %d\n", PSL_LOWIPL);
  	printf("#define\tPSL_HIGHIPL %d\n", PSL_HIGHIPL);
  	printf("#define\tPSL_USER %d\n", PSL_USER);
*** old-NetBSD/src/sys/arch/amiga/amiga/isr.h
--- NetBSD/src/sys/arch/amiga/amiga/isr.h
***************
*** 41,46 ****
--- 41,47 ----
  	int	(*isr_intr)();
  	void	*isr_arg;
  	int	isr_ipl;
+ 	int	isr_mapped_ipl;
  };
  
  #define	NISR		3
*** old-NetBSD/src/sys/arch/amiga/amiga/locore.s
--- NetBSD/src/sys/arch/amiga/amiga/locore.s
***************
*** 49,62 ****
  #include "assym.s"
  #include <amiga/amiga/vectors.s>
  #include <amiga/amiga/custom.h>
  
  #define CIAAADDR(ar)	movl	_CIAAbase,ar
  #define CIABADDR(ar)	movl	_CIABbase,ar
  #define CUSTOMADDR(ar)	movl	_CUSTOMbase,ar
  #define INTREQRADDR(ar)	movl	_INTREQRaddr,ar
  #define INTREQWADDR(ar)	movl	_INTREQWaddr,ar
! #define INTENAWADDR(ar) movl	_amiga_intena_write,ar
! #define	INTENARADDR(ar)	movl	_amiga_intena_read,ar
  
  	.text
  /*
--- 49,62 ----
  #include "assym.s"
  #include <amiga/amiga/vectors.s>
  #include <amiga/amiga/custom.h>
+ #include "ser.h"
  
  #define CIAAADDR(ar)	movl	_CIAAbase,ar
  #define CIABADDR(ar)	movl	_CIABbase,ar
  #define CUSTOMADDR(ar)	movl	_CUSTOMbase,ar
  #define INTREQRADDR(ar)	movl	_INTREQRaddr,ar
  #define INTREQWADDR(ar)	movl	_INTREQWaddr,ar
! #define INTENAWADDR(ar) movl	_INTENAWaddr,a0
  
  	.text
  /*
***************
*** 473,482 ****
   * Interrupt handlers.
   *
   *	Level 0:	Spurious: ignored.
!  *	Level 1:	builtin-RS232 TBE, softint (not used yet)
   *	Level 2:	keyboard (CIA-A) + DMA + SCSI
   *	Level 3:	VBL
!  *	Level 4:	not used
   *	Level 5:	builtin-RS232 RBF
   *	Level 6:	Clock (CIA-B-Timers)
   *	Level 7:	Non-maskable: shouldn't be possible. ignore.
--- 473,482 ----
   * Interrupt handlers.
   *
   *	Level 0:	Spurious: ignored.
!  *	Level 1:	builtin-RS232 TBE, softint
   *	Level 2:	keyboard (CIA-A) + DMA + SCSI
   *	Level 3:	VBL
!  *	Level 4:	Audio
   *	Level 5:	builtin-RS232 RBF
   *	Level 6:	Clock (CIA-B-Timers)
   *	Level 7:	Non-maskable: shouldn't be possible. ignore.
***************
*** 486,492 ****
   * and serial RBF (int5) specially, to improve performance
   */
  
! 	.globl	_intrhand, _hardclock
  
  _spurintr:
  	addql	#1,_intrcnt+0
--- 486,493 ----
   * and serial RBF (int5) specially, to improve performance
   */
  
! 	.globl	_intrhand
! 	.globl	_hardclock
  
  _spurintr:
  	addql	#1,_intrcnt+0
***************
*** 495,501 ****
  
  _lev5intr:
  	moveml	d0/d1/a0/a1,sp@-
- #include "ser.h"
  #if NSER > 0
  	jsr	_ser_fastint
  #else
--- 496,501 ----
***************
*** 510,520 ****
  _lev1intr:
  _lev2intr:
  _lev3intr:
- #ifndef LEV6_DEFER
  _lev4intr:
! #endif
! 	moveml	#0xC0C0,sp@-
! Lintrcommon:
  	lea	_intrcnt,a0
  	movw	sp@(22),d0		| use vector offset
  	andw	#0xfff,d0		|   sans frame type
--- 510,517 ----
  _lev1intr:
  _lev2intr:
  _lev3intr:
  _lev4intr:
! 	moveml	d0/d1/a0/a1,sp@-	| save scratch regs
  	lea	_intrcnt,a0
  	movw	sp@(22),d0		| use vector offset
  	andw	#0xfff,d0		|   sans frame type
***************
*** 523,622 ****
  	clrw	sp@-			|    padded to longword
  	jbsr	_intrhand		| handle interrupt
  	addql	#4,sp			| pop SR
! 	moveml	sp@+,#0x0303
  	addql	#1,_cnt+V_INTR
  	jra	rei
  
  _lev6intr:
! #ifdef LEV6_DEFER
! 	/*
! 	 * cause a level 4 interrupt (AUD3) to occur as soon
! 	 * as we return. Block generation of level 6 ints until
! 	 * we have dealt with this one.
! 	 */
! 	moveml	#0x8080,sp@-
  	INTREQRADDR(a0)
  	movew	a0@,d0
! 	btst	#INTB_EXTER,d0
! 	jeq	Llev6spur
! 	INTREQWADDR(a0)
! 	movew	#INTF_SETCLR+INTF_AUD3,a0@
! 	INTENAWADDR(a0)
! 	movew	#INTF_EXTER,a0@
! 	movew	#INTF_SETCLR+INTF_AUD3,a0@	| make sure THIS one is ok...
! 	moveml	sp@+,#0x0101
! 	rte
! Llev6spur:
! 	addql	#1,_intrcnt+36		| count spurious level 6 interrupts
! 	moveml	sp@+,#0x0101
! 	rte
! 
! _lev4intr:
! _fake_lev6intr:
! #endif
! 	moveml	#0xC0C0,sp@-
! #ifdef LEV6_DEFER
! 	/*
! 	 * check for fake level 6
! 	 */
! 	INTREQRADDR(a0)
! 	movew	a0@,d0
! 	btst	#INTB_EXTER,d0
! 	jeq	Lintrcommon		| if EXTER not pending, handle normally
! #endif
! 
! 	CIABADDR(a0)
! 	movb	a0@(CIAICR),d0		| read irc register (clears ints!)
! 	tstb	d0			| check if CIAB was source
! 	jeq	Lchkexter		| no, go through isr chain
! 	INTREQWADDR(a0)
! #ifndef LEV6_DEFER
! 	movew	#INTF_EXTER,a0@		| clear EXTER interrupt in intreq
! #else
! 	movew	#INTF_EXTER+INTF_AUD3,a0@ | clear EXTER & AUD3 in intreq
  	INTENAWADDR(a0)
! 	movew	#INTF_SETCLR+INTF_EXTER,a0@ | reenable EXTER interrupts
! #endif
! 	btst	#0,d0			| timerA interrupt?
! 	jeq     Lskipciab		| no
! | save d0 if we want to check other CIAB interrupts?
! 	lea	sp@(16),a1		| get pointer to PS
! 	movl	a1,sp@-			| push pointer to PS, PC
! 	jbsr	_hardclock		| call generic clock int routine
! 	addql	#4,sp			| pop params
! 	addql	#1,_intrcnt+32		| add another system clock interrupt
! Lskipciab:
! | process any other CIAB interrupts?
! Llev6done:
! 	moveml	sp@+,#0x0303		| restore scratch regs
  	addql	#1,_cnt+V_INTR		| chalk up another interrupt
! 	jra	rei			| all done [can we do rte here?]
! Lchkexter:
! | check to see if EXTER request is really set?
! 	movl	_isr_exter,a0		| get head of EXTER isr chain
! Lnxtexter:
! 	movl	a0,d0			| test if any more entries
! 	jeq	Lexterdone		| (spurious interrupt?)
! 	movl	a0,sp@-			| save isr pointer
! 	movl	a0@(ISR_ARG),sp@-
! 	movl	a0@(ISR_INTR),a0
! 	jsr	a0@			| call isr handler
! 	addql	#4,sp
! 	movl	sp@+,a0			| restore isr pointer
! 	movl	a0@(ISR_FORW),a0	| get next pointer
! 	tstl	d0			| did handler process the int?
! 	jeq	Lnxtexter		| no, try next
! Lexterdone:
! 	INTREQWADDR(a0)
! #ifndef LEV6_DEFER
! 	movew	#INTF_EXTER,a0@		| clear EXTER interrupt
! #else
! 	movew	#INTF_EXTER+INTF_AUD3,a0@ | clear EXTER & AUD3 interrupt
! 	INTENAWADDR(a0)
! 	movew	#INTF_SETCLR+INTF_EXTER,a0@ | reenable EXTER interrupts
! #endif
! 	addql	#1,_intrcnt+24		| count EXTER interrupts
! 	jra	Llev6done
  
  _lev7intr:
  	addql	#1,_intrcnt+28
--- 520,560 ----
  	clrw	sp@-			|    padded to longword
  	jbsr	_intrhand		| handle interrupt
  	addql	#4,sp			| pop SR
! 	moveml	sp@+,d0/d1/a0/a1	| restore scratch regs
  	addql	#1,_cnt+V_INTR
  	jra	rei
  
+ 	.globl	_isr_exter_ipl
+ 	.globl	_isr_exter_highipl
+ 	.globl	_isr_exter_lowipl
+ 	.globl	_hardclock_frame
+ 	
  _lev6intr:
! 	moveml	d0-d1/a0-a1,sp@-	| save clobbered regs
! #if 0
  	INTREQRADDR(a0)
  	movew	a0@,d0
! 	btst	#INTB_EXTER,d0		| check for non-EXTER INT6 ints
! 	jne	Lexter
! 	| register spurious int6 interrupt
! Lexter:	
! #endif
! 	moveal	#_hardclock_frame,a0	| store the clockframe
! 	movel	sp@(16),a0@+		| where hardclock will find it
! 	movel	sp@(20),a0@
  	INTENAWADDR(a0)
! 	movew	#INTF_EXTER,a0@		| disable EXTER ints
! 	movew	sp@(16),d0		| get PS-word
! 	andl	#PSL_IPL,d0		| only IPL is interesting
! 	orw	#PSL_S,d0		| note we're in kernel mode
! 	movel	d0,sp@-
! 	movel	_isr_exter_highipl,sp@-	| start out at the highest IPL
! 	jbsr	_walk_ipls		| run all ISRs at appropriate IPLs
! 	addql	#8,sp
! 	addql	#1,_intrcnt+24		| add another exter interrupt
! 	moveml	sp@+,d0-d1/a0-a1	| restore scratch regs
  	addql	#1,_cnt+V_INTR		| chalk up another interrupt
! 	jra	Lastchk			| all done [can we do rte here?]
  
  _lev7intr:
  	addql	#1,_intrcnt+28
***************
*** 627,633 ****
  	 */
  	rte				| all done
  
- 
  /*
   * Emulation of VAX REI instruction.
   *
--- 565,570 ----
***************
*** 653,658 ****
--- 590,607 ----
  	tstl	_panicstr		| have we paniced?
  	jne	Ldorte			| yes, do not make matters worse
  #endif
+ 	tstl	_isr_exter_ipl		| IPL lowering in process?
+ 	jeq	Lastchk			| no, go on to check for ASTs
+ 	moveml	d0-d1/a0-a1,sp@-	| save scratch regs
+ 	movw	sp@(16),d0		| get PS
+ 	andl	#PSL_IPL,d0		| we're only interested in the IPL
+ 	orw	#PSL_S,d0		| note that we're in kernel mode
+ 	movel	d0,sp@-
+ 	movel	_isr_exter_ipl,sp@-	| start where we left last walk_ipls
+ 	jbsr	_walk_ipls		| run needed ISRs
+ 	addql	#8,sp			| pop params
+ 	moveml	sp@+,d0-d1/a0-a1	| restore scratch regs
+ Lastchk:	
  	tstl	_astpending		| AST pending?
  	jeq	Ldorte			| no, done
  Lrei1:
***************
*** 737,742 ****
--- 686,697 ----
  	movl	#0xbfd000,_CIABbase
  	movl	#0xdff000,_CUSTOMbase
  
+ #ifdef BOOT_DEBUG
+ 	movl	#0xfff,sp@-
+ 	jbsr	_rollcolor
+ 	addql	#4,sp
+ #endif
+ 
  	/*
  	 * initialize the timer frequency
  	 */
***************
*** 2102,2119 ****
  /* interrupt counters */
  	.globl	_intrcnt,_eintrcnt,_intrnames,_eintrnames
  _intrnames:
! 	.asciz	"spur"		| spurious interrupt
! 	.asciz	"tbe/soft"	| serial TBE & software
! 	.asciz	"kbd/ports"	| keyboard & PORTS
! 	.asciz	"vbl"		| vertical blank
! 	.asciz	"audio"		| audio channels
! 	.asciz	"rbf"		| serial receive
! 	.asciz	"exter"		| EXTERN
! 	.asciz	"nmi"		| non-maskable
! 	.asciz	"clock"		| clock interrupts
! 	.asciz	"spur6"		| spurious level 6
  _eintrnames:
  	.align	2
  _intrcnt:
! 	.long	0,0,0,0,0,0,0,0,0,0
  _eintrcnt:
--- 2057,2072 ----
  /* interrupt counters */
  	.globl	_intrcnt,_eintrcnt,_intrnames,_eintrnames
  _intrnames:
! 	.asciz	"spur"
! 	.asciz	"tbe/soft"
! 	.asciz	"kbd/ports"
! 	.asciz	"vbl"
! 	.asciz	"audio"
! 	.asciz	"rbf"
! 	.asciz	"exter"
! 	.asciz	"nmi"
  _eintrnames:
  	.align	2
  _intrcnt:
! 	.long	0,0,0,0,0,0,0,0,0
  _eintrcnt:
*** old-NetBSD/src/sys/arch/amiga/amiga/machdep.c
--- NetBSD/src/sys/arch/amiga/amiga/machdep.c
***************
*** 138,144 ****
  /* the following is used externally (sysctl_hw) */
  char machine[] = "amiga";
   
!  /*
   * Console initialization: called early on from main,
   * before vm init or startup.  Do enough configuration
   * to choose and initialize a console.
--- 138,184 ----
  /* the following is used externally (sysctl_hw) */
  char machine[] = "amiga";
   
! struct isr *isr_ports;
! struct isr *isr_exter[7];
! int isr_exter_lowipl = 7;
! int isr_exter_highipl = 0;
! int isr_exter_ipl = 0;
! 
! /*
!  * Poll all registered ISRs starting at IPL start_ipl going down to
!  * isr_exter_lowipl.  If we reach the IPL of ending_psw along the way
!  * just return stating in isr_exter_ipl that we need to run the remaining
!  * layers later when the IPL gets lowered (i.e. a spl? call).  If some
!  * ISR handles the interrupt, or all layers have been processed, enable
!  * EXTER interrupts again and return.
!  */
! void
! walk_ipls (start_ipl, ending_psw)
! 	int start_ipl;
! 	int ending_psw;
! {
! 	int i;
! 	int handled = 0;
! 
! 	for (i = start_ipl; !handled && i >= isr_exter_lowipl; i--) {
! 		register int psw = i << 8 | PSL_S;
! 		struct isr *isr;
! 		      
! 		if (psw <= ending_psw) {
! 			isr_exter_ipl = i;
! 			return;
! 		}
! 		__asm __volatile("movew %0,sr" : : "d" (psw) : "cc");
! 		for (isr = isr_exter[i]; !handled && isr; isr = isr->isr_forw)
! 			handled = (*isr->isr_intr)(isr->isr_arg);
! 	}
! 	isr_exter_ipl = 0;
! 	__asm __volatile("movew %0,sr" : : "di" (PSL_S|PSL_IPL6) : "cc");
! 	custom.intreq = INTF_EXTER;
! 	custom.intena = INTF_SETCLR | INTF_EXTER;
! }
! 
! /*
   * Console initialization: called early on from main,
   * before vm init or startup.  Do enough configuration
   * to choose and initialize a console.
***************
*** 1078,1094 ****
   * function calls executed at very low interrupt priority.
   * Example for use is keyboard repeat, where the repeat 
   * handler running at splclock() triggers such a (hardware
!  * aided) software interrupt.
!  * Note: the installed functions are currently called in a
!  * LIFO fashion, might want to change this to FIFO
!  * later.
   */
  struct si_callback {
  	struct si_callback *next;
  	void (*function) __P((void *rock1, void *rock2));
  	void *rock1, *rock2;
  };
  static struct si_callback *si_callbacks;
  static struct si_callback *si_free;
  #ifdef DIAGNOSTIC
  static int ncb;		/* number of callback blocks allocated */
--- 1118,1134 ----
   * function calls executed at very low interrupt priority.
   * Example for use is keyboard repeat, where the repeat 
   * handler running at splclock() triggers such a (hardware
!  * aided) software interrupt.  These functions are called in
!  * a FIFO manner as expected.
   */
+ 
  struct si_callback {
  	struct si_callback *next;
  	void (*function) __P((void *rock1, void *rock2));
  	void *rock1, *rock2;
  };
  static struct si_callback *si_callbacks;
+ static struct si_callback *si_callbacks_end;
  static struct si_callback *si_free;
  #ifdef DIAGNOSTIC
  static int ncb;		/* number of callback blocks allocated */
***************
*** 1147,1154 ****
  	si->rock2 = rock2;
  
  	s = splhigh();
! 	si->next = si_callbacks;
! 	si_callbacks = si;
  	splx(s);
  
  	/*
--- 1187,1198 ----
  	si->rock2 = rock2;
  
  	s = splhigh();
! 	si->next = NULL;
! 	if (si_callbacks)
! 		si_callbacks_end->next = si;
! 	else
! 		si_callbacks = si;
! 	si_callbacks_end = si;
  	splx(s);
  
  	/*
***************
*** 1180,1185 ****
--- 1224,1231 ----
  				psi->next = nsi;
  			else
  				si_callbacks = nsi;
+ 			if (si == si_callbacks_end)
+ 				si_callbacks_end = psi;
  		}
  		si = nsi;
  	}
***************
*** 1197,1202 ****
--- 1243,1249 ----
  
  	do {
  		s = splhigh ();
+ 		/* Yes, that's an *assignment* below!  */
  		if (si = si_callbacks)
  			si_callbacks = si->next;
  		splx(s);
***************
*** 1224,1246 ****
  #endif
  }
  
- struct isr *isr_ports;
- struct isr *isr_exter;
- 
  void
  add_isr(isr)
  	struct isr *isr;
  {
  	struct isr **p, *q;
  
! 	p = isr->isr_ipl == 2 ? &isr_ports : &isr_exter;
  	while ((q = *p) != NULL)
  		p = &q->isr_forw;
  	isr->isr_forw = NULL;
  	*p = isr;
  	/* enable interrupt */
! 	custom.intena = isr->isr_ipl == 2 ? INTF_SETCLR | INTF_PORTS :
! 	    INTF_SETCLR | INTF_EXTER;
  }
  
  void
--- 1271,1296 ----
  #endif
  }
  
  void
  add_isr(isr)
  	struct isr *isr;
  {
  	struct isr **p, *q;
  
! 	p = isr->isr_ipl == 2 ? &isr_ports : &isr_exter[isr->isr_mapped_ipl];
! 	if (isr->isr_ipl == 6) {
! 		if (isr->isr_mapped_ipl > isr_exter_highipl)
! 			isr_exter_highipl = isr->isr_mapped_ipl;
! 		if (isr->isr_mapped_ipl < isr_exter_lowipl)
! 			isr_exter_lowipl = isr->isr_mapped_ipl;
! 	}
  	while ((q = *p) != NULL)
  		p = &q->isr_forw;
  	isr->isr_forw = NULL;
  	*p = isr;
  	/* enable interrupt */
! 	custom.intena = INTF_SETCLR |
! 	    (isr->isr_ipl == 2 ? INTF_PORTS : INTF_EXTER);
  }
  
  void
***************
*** 1249,1255 ****
  {
  	struct isr **p, *q;
  
! 	p = isr->isr_ipl == 6 ? &isr_exter : &isr_ports;
  	while ((q = *p) != NULL && q != isr)
  		p = &q->isr_forw;
  	if (q)
--- 1299,1305 ----
  {
  	struct isr **p, *q;
  
! 	p = isr->isr_ipl == 6 ? &isr_exter[isr->isr_mapped_ipl] : &isr_ports;
  	while ((q = *p) != NULL && q != isr)
  		p = &q->isr_forw;
  	if (q)
***************
*** 1257,1265 ****
  	else
  		panic("remove_isr: handler not registered");
  	/* disable interrupt if no more handlers */
! 	p = isr->isr_ipl == 6 ? &isr_exter : &isr_ports;
! 	if (*p == NULL)
! 		custom.intena = isr->isr_ipl == 6 ? INTF_EXTER : INTF_PORTS;
  }
  
  intrhand(sr)
--- 1307,1328 ----
  	else
  		panic("remove_isr: handler not registered");
  	/* disable interrupt if no more handlers */
! 	p = isr->isr_ipl == 6 ? &isr_exter[isr->isr_mapped_ipl] : &isr_ports;
! 	if (*p == NULL) {
! 		if (isr->isr_ipl == 6) {
! 			if (isr->isr_mapped_ipl == isr_exter_lowipl)
! 				while (isr_exter_lowipl++ < 6 &&
! 				    !isr_exter[isr_exter_lowipl])
! 					;
! 			if (isr->isr_mapped_ipl == isr_exter_ipl)
! 				while (isr_exter_highipl-- > 0 &&
! 				    !isr_exter[isr_exter_highipl])
! 					;
! 			if (isr_exter_lowipl == 7)
! 				custom.intena = INTF_EXTER;
! 		} else if (isr->isr_ipl == 2)
! 			custom.intena = INTF_PORTS;
! 	}
  }
  
  intrhand(sr)
***************
*** 1292,1298 ****
  			/*
  			 * first clear the softint-bit
  			 * then process all classes of softints.
! 			 * this order is dicated by the nature of 
  			 * software interrupts.  The other order
  			 * allows software interrupts to be missed
  			 */
--- 1355,1361 ----
  			/*
  			 * first clear the softint-bit
  			 * then process all classes of softints.
! 			 * this order is dictated by the nature of 
  			 * software interrupts.  The other order
  			 * allows software interrupts to be missed
  			 */
***************
*** 1329,1339 ****
  		break;
      case 3: 
        /* VBL */
! 		if (ireq & INTF_BLIT)  
  			blitter_handler();
! 		if (ireq & INTF_COPER)  
  			copper_handler();
! 		if (ireq & INTF_VERTB) 
  			vbl_handler();
  		break;
  #if 0
--- 1392,1402 ----
  		break;
      case 3: 
        /* VBL */
! 		if (ireq & INTF_BLIT)
  			blitter_handler();
! 		if (ireq & INTF_COPER)
  			copper_handler();
! 		if (ireq & INTF_VERTB)
  			vbl_handler();
  		break;
  #if 0
***************
*** 1422,1428 ****
  
  	if (doingdump)
  		return;
! 	s = splhigh();
  	doingdump = 1;
  	printf("pid = %d, pc = %s, ", curproc->p_pid, hexstr(fp->f_pc, 8));
  	printf("ps = %s, ", hexstr(fp->f_sr, 4));
--- 1485,1491 ----
  
  	if (doingdump)
  		return;
! 	s = spl7();
  	doingdump = 1;
  	printf("pid = %d, pc = %s, ", curproc->p_pid, hexstr(fp->f_pc, 8));
  	printf("ps = %s, ", hexstr(fp->f_sr, 4));
***************
*** 1528,1530 ****
--- 1591,1599 ----
  #endif
  	return(error);
  }
+ 
+ #ifdef SPL_PROF
+ struct _spl_ent _spl_stack[256];
+ struct _spl_ent *_spl_p = _spl_stack;
+ int spl_debug = 0, spl_prof = 0;
+ #endif
*** old-NetBSD/src/sys/arch/amiga/amiga/trap.c
--- NetBSD/src/sys/arch/amiga/amiga/trap.c
***************
*** 219,224 ****
--- 219,225 ----
  	struct frame *fp;
  {
  	static int panicing = 0;
+ 
  	if (panicing++ == 0) {
  		printf("trap type %d, code = %x, v = %x\n", type, code, v);
  		regdump(fp, 128);
***************
*** 638,647 ****
--- 639,650 ----
  		return;
  	}
  
+ #if 0
  #ifdef DEBUG
  	if (i != SIGTRAP)
  		printf("trapsignal(%d, %d, %d, %x, %x)\n", p->p_pid, i,
  		    ucode, v, frame.f_regs[PC]);
+ #endif
  #endif
  	trapsignal(p, i, ucode);
  	if ((type & T_USER) == 0)
